<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>discover: Devices</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.4.2 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="dirs.html">Directories</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="globals.html">Globals</a></div>
<h1>Devices</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga0">discover_device_find</a> (char *discover_class, <a class="el" href="structdiscover__error.html">discover_error_t</a> *status)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga4">discover_device_get_data</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device, char *discover_class, char *version, <a class="el" href="structdiscover__error.html">discover_error_t</a> *status)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga5">discover_device_copy</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *src, <a class="el" href="group__types.html#ga3">discover_device_t</a> *dst)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga6">discover_data_get_class</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga7">discover_data_get_text</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga8">discover_data_get_parent</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga9">discover_data_get_child</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga10">discover_data_get_next</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga11">discover_data_get_prev</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga12">discover_data_get_first</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga13">discover_data_new</a> (void)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga14">discover_data_free</a> (<a class="el" href="group__types.html#ga4">discover_data_t</a> *data_tree)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga15">discover_device_get_busclass</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga16">discover_device_get_model_id</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga17">discover_device_get_model_name</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga18">discover_device_get_vendor_id</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga19">discover_device_get_vendor_name</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga20">discover_device_get_data_struct</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga21">discover_device_get_next</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *device)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga22">discover_device_new</a> (void)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__device.html#ga23">discover_device_free</a> (<a class="el" href="group__types.html#ga3">discover_device_t</a> *devices, int free_data)</td></tr>

</table>
<hr><h2>Function Documentation</h2>
<a class="anchor" name="ga14" doxytag="device.c::discover_data_free"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">void discover_data_free           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data_tree</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Free the data tree. Note that unlike the other free functions in Discover, this one does not free data_tree itself. This is a side-effect of how it is implemented. It frees all children and siblings of data_tree as well as the data. After calling discover_data_free, you have to call free(3) on data_tree itself.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>data_tree</em>&nbsp;</td><td>Data tree to free </td></tr>
  </table>
</dl>

<p>
Definition at line <a class="el" href="device_8c-source.html#l00436">436</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
References <a class="el" href="device_8c-source.html#l00436">discover_data_free()</a>.
<p>
Referenced by <a class="el" href="device_8c-source.html#l00436">discover_data_free()</a>, and <a class="el" href="device_8c-source.html#l00592">discover_device_free()</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga9" doxytag="device.c::discover_data_get_child"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_data_get_child           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the child member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00341">341</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga6" doxytag="device.c::discover_data_get_class"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_data_get_class           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the class member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00308">308</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga12" doxytag="device.c::discover_data_get_first"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_data_get_first           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the first member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00374">374</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga10" doxytag="device.c::discover_data_get_next"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_data_get_next           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the next member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00352">352</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga8" doxytag="device.c::discover_data_get_parent"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_data_get_parent           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the parent member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00330">330</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga11" doxytag="device.c::discover_data_get_prev"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_data_get_prev           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the prev member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00363">363</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga7" doxytag="device.c::discover_data_get_text"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_data_get_text           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>data</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the text member of data. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00319">319</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga13" doxytag="device.c::discover_data_new"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_data_new           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">void&nbsp;</td>
          <td class="mdname1" valign="top" nowrap>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Create and initialize a new discover_data_t structure. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00409">409</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
Referenced by <a class="el" href="sysdep_8c-source.html#l00135">_discover_convert_device_data()</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga5" doxytag="device.c::discover_device_copy"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">void discover_device_copy           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="md" nowrap align="right"></td>
          <td class="md"></td>
          <td class="md" nowrap><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>dst</em></td>
        </tr>
        <tr>
          <td class="md"></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Copy a device structure.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>src</em>&nbsp;</td><td>Copy from (source) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>dst</em>&nbsp;</td><td>Copy to (destination) </td></tr>
  </table>
</dl>

<p>
Definition at line <a class="el" href="device_8c-source.html#l00268">268</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
Referenced by <a class="el" href="device_8c-source.html#l00063">discover_device_find()</a>, and <a class="el" href="device-xml_8c-source.html#l00614">discover_xml_get_matching_devices()</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga0" doxytag="device.c::discover_device_find"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a>* discover_device_find           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">char *&nbsp;</td>
          <td class="mdname" nowrap> <em>discover_class</em>, </td>
        </tr>
        <tr>
          <td class="md" nowrap align="right"></td>
          <td class="md"></td>
          <td class="md" nowrap><a class="el" href="structdiscover__error.html">discover_error_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>status</em></td>
        </tr>
        <tr>
          <td class="md"></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get a list of devices of a specified class on all buses scanned by default.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>discover_class</em>&nbsp;</td><td>Class of devices to find </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>status</em>&nbsp;</td><td>Address in which to place status report </td></tr>
  </table>
</dl>

<p>
Definition at line <a class="el" href="device_8c-source.html#l00063">63</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
References <a class="el" href="discover_8h-source.html#l00108">discover_error::code</a>, <a class="el" href="discover_8h-source.html#l00112">discover_error::create_message</a>, <a class="el" href="conf_8c-source.html#l00496">discover_conf_get_full_bus_map()</a>, <a class="el" href="device_8c-source.html#l00268">discover_device_copy()</a>, <a class="el" href="device_8c-source.html#l00551">discover_device_get_next()</a>, <a class="el" href="device_8c-source.html#l00562">discover_device_new()</a>, <a class="el" href="group__types.html#gga15a22">DISCOVER_EDEVICENOTFOUND</a>, <a class="el" href="sysdep_8c-source.html#l00206">discover_get_devices()</a>, <a class="el" href="group__types.html#gga15a15">DISCOVER_SUCCESS</a>, <a class="el" href="busclass-xml_8c-source.html#l00295">discover_xml_busclass_cmp()</a>, and <a class="el" href="busclass-xml_8c-source.html#l00213">discover_xml_get_busclasses()</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga23" doxytag="device.c::discover_device_free"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">void discover_device_free           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>devices</em>, </td>
        </tr>
        <tr>
          <td class="md" nowrap align="right"></td>
          <td class="md"></td>
          <td class="md" nowrap>int&nbsp;</td>
          <td class="mdname" nowrap> <em>free_data</em></td>
        </tr>
        <tr>
          <td class="md"></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Free the device or list of devices. Pass 1 as the second argument to free the data structure for this device, 0 to leave it. It is necessary to specify 0 when one structure was copied from another with discover_device_copy. Otherwise, you must pass 1.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>devices</em>&nbsp;</td><td>Device or list of devices to free </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>free_data</em>&nbsp;</td><td>Whether to free the data structure </td></tr>
  </table>
</dl>

<p>
Definition at line <a class="el" href="device_8c-source.html#l00592">592</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
References <a class="el" href="device_8c-source.html#l00436">discover_data_free()</a>.
<p>
Referenced by <a class="el" href="sysdep_8c-source.html#l00301">discover_free_devices()</a>, and <a class="el" href="device-xml_8c-source.html#l00531">discover_xml_free_devices()</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga15" doxytag="device.c::discover_device_get_busclass"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_device_get_busclass           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the busclass member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00485">485</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga4" doxytag="device.c::discover_device_get_data"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_device_get_data           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>device</em>, </td>
        </tr>
        <tr>
          <td class="md" nowrap align="right"></td>
          <td class="md"></td>
          <td class="md" nowrap>char *&nbsp;</td>
          <td class="mdname" nowrap> <em>discover_class</em>, </td>
        </tr>
        <tr>
          <td class="md" nowrap align="right"></td>
          <td class="md"></td>
          <td class="md" nowrap>char *&nbsp;</td>
          <td class="mdname" nowrap> <em>version</em>, </td>
        </tr>
        <tr>
          <td class="md" nowrap align="right"></td>
          <td class="md"></td>
          <td class="md" nowrap><a class="el" href="structdiscover__error.html">discover_error_t</a> *&nbsp;</td>
          <td class="mdname" nowrap> <em>status</em></td>
        </tr>
        <tr>
          <td class="md"></td>
          <td class="md">)&nbsp;</td>
          <td class="md" colspan="2"></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the data matching the class path and version number (optional) from the device structure.<p>
The class parameter requires further explanation. The XML data sources have hierarchical data elements for each device. You access the data in an element by specifying the path along the data elements to it.<p>
For example, device elements for video cards usually have a data element of class "xfree86" containing data related to the XFree86 package; that element itself usually contains a data element of class "server" that specifies which server to use for this video card. You access this data by passing the string "xfree86/server" to this function.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>device</em>&nbsp;</td><td>Device from which to get the data </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>discover_class</em>&nbsp;</td><td>Class to search for </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>version</em>&nbsp;</td><td>Version number to require (NULL for unversioned search) </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>status</em>&nbsp;</td><td>Address in which to place status report </td></tr>
  </table>
</dl>

<p>
Definition at line <a class="el" href="device_8c-source.html#l00204">204</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
References <a class="el" href="discover_8h-source.html#l00108">discover_error::code</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga20" doxytag="device.c::discover_device_get_data_struct"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga4">discover_data_t</a>* discover_device_get_data_struct           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the data member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00540">540</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga16" doxytag="device.c::discover_device_get_model_id"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_device_get_model_id           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the model_id member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00496">496</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga17" doxytag="device.c::discover_device_get_model_name"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_device_get_model_name           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the model_name member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00507">507</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga21" doxytag="device.c::discover_device_get_next"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a>* discover_device_get_next           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the next member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00551">551</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
Referenced by <a class="el" href="device_8c-source.html#l00063">discover_device_find()</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga18" doxytag="device.c::discover_device_get_vendor_id"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_device_get_vendor_id           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the vendor_id member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00518">518</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga19" doxytag="device.c::discover_device_get_vendor_name"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top">char* discover_device_get_vendor_name           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a> *&nbsp;</td>
          <td class="mdname1" valign="top" nowrap> <em>device</em>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Get the vendor_name member of device. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00529">529</a> of file <a class="el" href="device_8c-source.html">device.c</a>.    </td>
  </tr>
</table>
<a class="anchor" name="ga22" doxytag="device.c::discover_device_new"></a><p>
<table class="mdTable" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"><a class="el" href="group__types.html#ga3">discover_device_t</a>* discover_device_new           </td>
          <td class="md" valign="top">(&nbsp;</td>
          <td class="md" nowrap valign="top">void&nbsp;</td>
          <td class="mdname1" valign="top" nowrap>          </td>
          <td class="md" valign="top">&nbsp;)&nbsp;</td>
          <td class="md" nowrap></td>
        </tr>
      </table>
    </td>
  </tr>
</table>
<table cellspacing="5" cellpadding="0" border="0">
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Create and initialize a new discover_device_t structure. 
<p>
Definition at line <a class="el" href="device_8c-source.html#l00562">562</a> of file <a class="el" href="device_8c-source.html">device.c</a>.
<p>
Referenced by <a class="el" href="device_8c-source.html#l00063">discover_device_find()</a>, <a class="el" href="sysdep_8c-source.html#l00206">discover_get_devices()</a>, and <a class="el" href="device-xml_8c-source.html#l00614">discover_xml_get_matching_devices()</a>.    </td>
  </tr>
</table>
<hr size="1"><address style="align: right;"><small>Generated on Thu Jul 28 03:38:01 2005 for discover by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.2 </small></address>
</body>
</html>
